// file: TomCat.cpp

#include <stdio.h>
//#include "nios.h" 

#include "tc_vars.h"
#include "hardware_t.h"
#include "flash_t.h"
#include "display_t.h"
#include "signal_t.h"
#include "commif_t.h"
#include "userif_t.h"

int main(void)										// Main program
{
	//Display Screen;
	//Hardware HW_Device;
	//AMDFlash Flash;
	
	
	//int irq_temp = 1;
	//int irq_temp_old = 1;
	//unsigned long main_loop_cnt = 0;
	
//	np_pio *out_test = na_test_out;	
//	out_test->np_pioedgecapture = 0x00; 						// clear all existing IRQ conditions
//	out_test->np_piodirection = 0x01;						// set all bits to output
//	out_test->np_piodata = 0x00;
//	out_test->np_piodata = 0x01;
//	out_test->np_piodata = 0x00;
	
	printf("\r\nbeta firmware starting!\r\n\r\n");	
	
	printf("- Flash initialization\r");
	//Flash.Init();
	AMDFlash::Init();
	printf("- Flash initialization                  - done\r\n");
	
	printf("- Hardware initialization\r");
	//HW_Device.Init();
	Hardware::Init();
	printf("- Hardware initialization               - done\r\n");
	
	printf("- Display initialization\r");
	//Screen.Init();
	Display::Init();
	printf("- Display initialization                - done\r\n");
	
	printf("- Restore settings from flash\r");
	Hardware::Restore_From_Flash();
	printf("- Restore settings from flash            - done\r\n");

	//HW_Device.Start_Record();		//start sampling
	Hardware::Start_Record();
	
	printf("Ready - press h for help\r\n");

	
	while (0 == 0)
	{
		//irq_temp = HW_Device.Read_IRQ();
			
		//HW_Device.Reset_the_Watchdog();						// Reset the WatchDog
	
		//HW_Device.Rotary_Interface();
		UserIF::Rotary_Interface();
		//HW_Device.Keyboard_Interface();
		UserIF::Keyboard_Interface();
		//HW_Device.Handle_ADC();
		Hardware::Handle_ADC();
		Signal::ProcessSignalData();
		//Screen.DrawSignals(1);
		Display::DrawSignals(1);		
		//HW_Device.TransferPlanes();
		Hardware::TransferPlanes();
		//HW_Device.Transfer_USB_Data();
		CommIF::Transfer_USB_Data();
		//Flash.Write_Config_Flash();
		AMDFlash::Write_Config_Flash();
	}
	
	return 0;									// Exit
}



